//
//  NewProjectViewController.m
//  DG
//
//  Created by Mark Brindle on 11/07/2011.
//  Copyright 2011 ARKEMM Software Limited. All rights reserved.
//

#import "NewProjectViewController.h"

@implementation NewProjectViewController
@synthesize nameField;
@synthesize updateSwitch;
@synthesize synchroniseSwitch;
@synthesize budgetField;
@synthesize rateField;
@synthesize commentField;

// Backing fields
@synthesize name;
@synthesize updatable;
@synthesize synchronise;
@synthesize budget;
@synthesize rate;
@synthesize comments;


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
  [self setNameField:nil];
  [self setUpdateSwitch:nil];
  [self setSynchroniseSwitch:nil];
  [self setBudgetField:nil];
  [self setRateField:nil];
  [self setCommentField:nil];
  [super viewDidUnload];
  // Release any retained subviews of the main view.
  // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Added methods (did not exist in original template code)

- (id)init {
  // Call our parent initialiser
  self = [super initWithNibName:nil bundle:nil];
  
  // Do our own setup now
  [self setTitle:@"New Project"];
  
  // Set up navigation items
  UIBarButtonItem *bbi;
  
  // Done item
  bbi = [[UIBarButtonItem alloc]
         initWithBarButtonSystemItem:UIBarButtonSystemItemDone 
         target:self
         action:@selector(create:)];
  [[self navigationItem]setRightBarButtonItem:bbi];
  
  // Cancel item
  bbi = [[UIBarButtonItem alloc] 
         initWithBarButtonSystemItem:UIBarButtonSystemItemCancel 
         target:self 
         action:@selector(cancel:)];
  
  return self;
}

- (IBAction)create:(id)sender {
  // Set our property values from details provided by the user
  [self setName:[nameField text]];
  [self setUpdatable:[updateSwitch state]];
  [self setSynchronise:[updateSwitch state]];
  [self setBudget:[budgetField text]];
  [self setRate:[rateField text]];
  [self setComments:[commentField text]];
  
  // Slide back to the previous view controller
  [[self navigationController] popViewControllerAnimated:YES];
}

- (IBAction)cancel:(id)sender {
  // Clear out any values set by the user
  [self setName:nil];
  [self setUpdatable:YES];
  [self setSynchronise:NO];
  [self setBudget:nil];
  [self setRate:nil];
  [self setComments:nil];
  
  // Slide back to the previous view controller
  [[self navigationController] popViewControllerAnimated:YES];
}

// Text field methods

- (IBAction)textFieldDoneEditing:(id)sender {
  // Called whenever a text field loses focus.  Calling resignFirstResponder on
  // the sender will cause it to hide the keyboard.
  [sender resignFirstResponder];
}

@end
